// JVSDKPDEMODlg.cpp : implementation file
//

#include "stdafx.h"
#include "JVSDKPDEMO.h"
#include "JVSDKPDEMODlg.h"
#include "JVSDKP.h"
#pragma comment(lib,"JVSDKP.lib")
#include "JVMATRIX.h"
#pragma comment(lib,"JVMATRIX.lib")
#include "pconfig.h"
#include "FullScreenDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//ݸSDKԶϢSDKطɺôϢ֪ͨӦó
#define WM_JVSP_NOTIFY		WM_USER+0x500

void FuncYv12Callback(int nPlayer, PUCHAR pY, PUCHAR pU, PUCHAR pV, DWORD dwStrideY, DWORD dwStrideUV);

PCONFIG g_pconfig;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJVSDKPDEMODlg dialog

CJVSDKPDEMODlg::CJVSDKPDEMODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJVSDKPDEMODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJVSDKPDEMODlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	memset(&g_pconfig, 0, sizeof(PCONFIG));
	m_nCurSel = 0;
	m_bInit	=	FALSE;
}

void CJVSDKPDEMODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJVSDKPDEMODlg)
	DDX_Control(pDX, IDC_LIST_INFO, m_lstInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJVSDKPDEMODlg, CDialog)
	//{{AFX_MSG_MAP(CJVSDKPDEMODlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_OPEN_FILE, OnButtonOpenFile)
	ON_BN_CLICKED(IDC_BUTTON_RELEASE_PLAYER, OnButtonReleasePlayer)
	ON_BN_CLICKED(IDC_BUTTON_PLAY, OnButtonPlay)
	ON_BN_CLICKED(IDC_BUTTON_PAUSE, OnButtonPause)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_CREATE, OnButtonCreate)
	ON_BN_CLICKED(IDC_BUTTON_INIT_SDK, OnButtonInitSdk)
	ON_BN_CLICKED(IDC_BUTTON_RELEASE_SDK, OnButtonReleaseSdk)
	ON_BN_CLICKED(IDC_BUTTON_FRAME_RATE, OnButtonFrameRate)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, OnDeltaposSpin1)
	ON_BN_CLICKED(IDC_BUTTON_GET_CURFRAME, OnButtonGetCurframe)
	ON_BN_CLICKED(IDC_BUTTON_STEP_FORWARD, OnButtonStepForward)
	ON_BN_CLICKED(IDC_BUTTON_BITMAP, OnButtonBitmap)
	ON_BN_CLICKED(IDC_BUTTON_GET_IDR_POS, OnButtonGetIdrPos)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_FULL_SCREEN, OnButtonFullScreen)
	ON_WM_RBUTTONDBLCLK()
	ON_WM_LBUTTONDBLCLK()
	ON_BN_CLICKED(IDC_BUTTON_BACK_IDR, OnButtonBackIdr)
	ON_WM_MOVE()
	ON_BN_CLICKED(IDC_BUTTON_LINK, OnButtonLink)
	ON_BN_CLICKED(IDC_BUTTON_UNLINK, OnButtonUnlink)
	ON_BN_CLICKED(IDC_CHECK_PLAY_AUDIO, OnCheckPlayAudio)
	ON_BN_CLICKED(IDC_BUTTON_PLAY_KEYFRAME, OnButtonPlayKeyframe)
	ON_BN_CLICKED(IDC_BUTTON_STOP_KEYFRAME, OnButtonStopKeyframe)
	ON_BN_CLICKED(IDC_CHECK_C501Output, OnCHECKC501Output)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_JVSP_NOTIFY, OnSDKNotify)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJVSDKPDEMODlg message handlers

BOOL CJVSDKPDEMODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SetDlgItemInt(IDC_EDIT_FRAME_RATE, 0);	
	for (int i=0; i<JDVR_MAX_PLAYER;i++)
	{
		g_pconfig.PLAYER[i].nPlayer = -1;	//-1ʾûд
	}
	m_nCurSel = 0;		//ĬϵǰѡĲΪһ
	
	SetDlgItemText(IDC_EDIT_IP, "127.0.0.1");
	SetDlgItemInt(IDC_EDIT_PORT, 9100);
	SetDlgItemInt(IDC_EDIT_PLAY_INTERVAL, 100);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CJVSDKPDEMODlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CJVSDKPDEMODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1 && g_pconfig.PLAYER[m_nCurSel].dwPlayStatus > 0)
		{
			JVSP_RefreshWindow(g_pconfig.PLAYER[m_nCurSel].nPlayer);
		}
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CJVSDKPDEMODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CJVSDKPDEMODlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	m_JdvrSock.StopLink();
	if (m_JdvrSock.m_bInThread)	//һ߳δ˳
	{
		WaitForSingleObject(m_JdvrSock.m_pWinThread->m_hThread, 1000);
	}


	//ͷŲSDK
	JVSP_ReleaseSDK();
	//ͷŽ뿨SDK
	JVM_ReleaseSDK();
}

void CJVSDKPDEMODlg::OnButtonOpenFile() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		if (JVSP_OpenFile(g_pconfig.PLAYER[m_nCurSel].nPlayer, "test300.mp4"))
		{
			g_pconfig.PLAYER[m_nCurSel].nTotalFrames = JVSP_GetTotalFrames(g_pconfig.PLAYER[m_nCurSel].nPlayer);
			CString s;
			s.Format("Open the file successfully, total number of frames is :%d", g_pconfig.PLAYER[m_nCurSel].nTotalFrames);
			m_lstInfo.AddString(s);
		}
		else
		{
			m_lstInfo.AddString("Open the file failed");
		}
	}
}

void CJVSDKPDEMODlg::OnButtonReleasePlayer() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		m_JdvrSock.StopLink();
		JVSP_ReleasePlayer(g_pconfig.PLAYER[m_nCurSel].nPlayer);
		g_pconfig.PLAYER[m_nCurSel].nPlayer = -1;
		m_lstInfo.AddString("release tbe players Successfully");
		if (g_pconfig.dwTotalMatrix > 0)
		{
			JVM_CloseMatrix(0);
		}
	}
}

void CJVSDKPDEMODlg::OnButtonPlay() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		RECT rt;
		this->GetWindowRect(&rt);
		rt.left += 13;
		rt.right = rt.left + 352;
		rt.top += 32;
		rt.bottom = rt.top + 288;
		JVSP_SetVideoPreview(g_pconfig.PLAYER[m_nCurSel].nPlayer, this->GetSafeHwnd(), &rt, TRUE);
		JVSP_Play(g_pconfig.PLAYER[m_nCurSel].nPlayer);
		g_pconfig.PLAYER[m_nCurSel].dwPlayStatus = 1;
		m_lstInfo.SetCurSel(m_lstInfo.AddString("Start playing"));
	}
}

LRESULT CJVSDKPDEMODlg::OnSDKNotify(WPARAM wParam, LPARAM lParam)
{
	int nPlayer = (int)wParam;
	switch (lParam)
	{
	case WM_LPARAM_STOP:
		JVSP_Stop(nPlayer);
		g_pconfig.PLAYER[m_nCurSel].dwPlayStatus = 3;
		m_lstInfo.SetCurSel(m_lstInfo.AddString("End of playback"));
		break;
	case WM_LPARAM_BITMAP:
		GetSdkBitmap(nPlayer);
		break;
	default:
		break;

	}
	return TRUE;
}

void CJVSDKPDEMODlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CJVSDKPDEMODlg::OnButtonPause() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		JVSP_Pause(g_pconfig.PLAYER[m_nCurSel].nPlayer);
		g_pconfig.PLAYER[m_nCurSel].dwPlayStatus = 2;
		m_lstInfo.AddString("Pause");
	}
	
}

void CJVSDKPDEMODlg::OnButtonStop() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		JVSP_Stop(g_pconfig.PLAYER[m_nCurSel].nPlayer);
		g_pconfig.PLAYER[m_nCurSel].dwPlayStatus = 3;
		m_lstInfo.SetCurSel(m_lstInfo.AddString("Stop"));
	}
	
}

void CJVSDKPDEMODlg::OnButtonCreate() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.bDDrawOK)
	{
		int nPlayer = JVSP_CreatePlayer();
		if (nPlayer == -1)
		{
			m_lstInfo.AddString("Failed to create player");
		}
		else
		{
			g_pconfig.PLAYER[m_nCurSel].nPlayer = nPlayer;
			m_lstInfo.AddString("Creating player successfully");
			m_bInit	=	TRUE;
			if (g_pconfig.dwTotalMatrix > 0 )
			{
				//ھ󿨵Ļ򿪵һ·
				JVM_OpenMatrix(0);
			}
		}
	}
}

void CJVSDKPDEMODlg::OnButtonInitSdk() 
{
	// TODO: Add your control notification handler code here
	//ʶSDK
	if (JVSP_InitSDK())
	{
		int nDeviceNum;
		g_pconfig.bDDrawOK = TRUE;
		m_lstInfo.AddString("Successful initialization SDK");
		//ԶϢݸSDK
		JVSP_RegisterNotify(this->GetSafeHwnd(), WM_JVSP_NOTIFY);
		//עص
		JVSP_SetCallBack(FuncYv12Callback);

		nDeviceNum = JVM_InitSDK();
		if (nDeviceNum > 0)
		{
			CString s;
			s.Format("SDK detects %d decoder device(s)", nDeviceNum);
			m_lstInfo.AddString(s);
		}
		g_pconfig.dwTotalMatrix = nDeviceNum;
	}
	else
	{
		m_lstInfo.AddString("Failed to initialize SDK");
	}
	
}

void CJVSDKPDEMODlg::OnButtonReleaseSdk() 
{
	// TODO: Add your control notification handler code here
	JVSP_ReleaseSDK();
	JVM_ReleaseSDK();
}

void CJVSDKPDEMODlg::OnButtonFrameRate() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		JVSP_SetFPS(g_pconfig.PLAYER[m_nCurSel].nPlayer, ((CButton *)GetDlgItem(IDC_CHECK_FAST_PLAY))->GetCheck(), GetDlgItemInt(IDC_EDIT_FRAME_RATE));
		m_lstInfo.SetCurSel(m_lstInfo.AddString("Set the playback speed"));
	}
	
}

void CJVSDKPDEMODlg::OnDeltaposSpin1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	int n = GetDlgItemInt(IDC_EDIT_FRAME_RATE);
	if (pNMUpDown->iDelta > 0)	//
	{
		n--;
		if (n<0) n=0;
	}
	else		//
	{
		n++;
	}
	SetDlgItemInt(IDC_EDIT_FRAME_RATE, n);
	
	*pResult = 0;
}

void CJVSDKPDEMODlg::OnButtonGetCurframe() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		CString s;
		s.Format("Current frame%d", JVSP_GetCurFrameNum(g_pconfig.PLAYER[m_nCurSel].nPlayer));
		m_lstInfo.SetCurSel(m_lstInfo.AddString(s));
	}
}

void CJVSDKPDEMODlg::OnButtonStepForward() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		JVSP_StepForward(g_pconfig.PLAYER[m_nCurSel].nPlayer);
		CString s;
		s.Format("Current frame%d", JVSP_GetCurFrameNum(g_pconfig.PLAYER[m_nCurSel].nPlayer));
		m_lstInfo.SetCurSel(m_lstInfo.AddString(s));
	}
	
}

void CJVSDKPDEMODlg::OnButtonBitmap() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		if (g_pconfig.PLAYER[m_nCurSel].Bitmap.pRGB != NULL)
		{
			return;	//Ѿ˵һץͼûн
		}

		JVSP_GetBitmapSize(m_nCurSel, &g_pconfig.PLAYER[m_nCurSel].Bitmap.dwWidth, &g_pconfig.PLAYER[m_nCurSel].Bitmap.dwHeight);
		
		g_pconfig.PLAYER[m_nCurSel].Bitmap.pRGB = new UCHAR[g_pconfig.PLAYER[m_nCurSel].Bitmap.dwWidth * g_pconfig.PLAYER[m_nCurSel].Bitmap.dwHeight * 4];
		if (g_pconfig.PLAYER[m_nCurSel].Bitmap.pRGB)
		{
			JVSP_GetBitmap(m_nCurSel, g_pconfig.PLAYER[m_nCurSel].Bitmap.pRGB);
		}
	}
}

void CJVSDKPDEMODlg::OnButtonGetIdrPos() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		ULONG ulKeyFramePos;
		ULONG ulFrameNum;
		if (JVSP_GetKeyFramePos(g_pconfig.PLAYER[m_nCurSel].nPlayer, &ulKeyFramePos, &ulFrameNum))
		{
			CString s;
			s.Format("Current keyframe offset%dFrames offset%d", ulKeyFramePos, ulFrameNum);
			m_lstInfo.SetCurSel(m_lstInfo.AddString(s));
		}
	}
	
}

void CJVSDKPDEMODlg::OnButtonOpen() 
{
	// TODO: Add your control notification handler code here

	if (g_pconfig.PLAYER[m_nCurSel].nPlayer != -1)
	{
		OPENFILENAME ofn={0};
		char sFilename[MAX_PATH]={0};

		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = this->m_hWnd ;
		ofn.lpstrFilter = NULL;
		ofn.lpstrFilter = "Record files\0*.mp4\0All files\0*.*\0";
		ofn.lpstrCustomFilter = NULL;
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = sFilename;
		ofn.nMaxFile = MAX_PATH;
		ofn.lpstrTitle = TEXT("Please select video file\0");
		ofn.lpstrFileTitle = NULL;
		ofn.lpstrDefExt = TEXT("*\0");
		ofn.Flags = OFN_FILEMUSTEXIST | OFN_READONLY | OFN_PATHMUSTEXIST;
		ofn.lpstrInitialDir = NULL;
		if(!GetOpenFileName((LPOPENFILENAME)&ofn))
			return ;

		if (JVSP_OpenFile(g_pconfig.PLAYER[m_nCurSel].nPlayer, sFilename))
		{
			g_pconfig.PLAYER[m_nCurSel].nTotalFrames = JVSP_GetTotalFrames(g_pconfig.PLAYER[m_nCurSel].nPlayer);
			CString s;
			s.Format("Open the file %s success", sFilename);
			m_lstInfo.AddString(s);
			s.Format("Total number of frames:%d", g_pconfig.PLAYER[m_nCurSel].nTotalFrames);
			m_lstInfo.SetCurSel(m_lstInfo.AddString(s));
		}
		else
		{
			m_lstInfo.AddString("Open the file failed");
		}
	}

}

void CJVSDKPDEMODlg::OnButtonFullScreen() 
{
	// TODO: Add your control notification handler code here
	CFullScreenDlg	cd;

	cd.SetPlayerID(g_pconfig.PLAYER[m_nCurSel].nPlayer);
	cd.DoModal();

	//ڱԤ
	RECT rt;
	this->GetWindowRect(&rt);
	rt.left += 13;
	rt.right = rt.left + 352;
	rt.top += 32;
	rt.bottom = rt.top + 288;
	JVSP_SetVideoPreview(g_pconfig.PLAYER[m_nCurSel].nPlayer, this->GetSafeHwnd(), &rt, TRUE);
}

void CJVSDKPDEMODlg::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer == -1)
		return;

	//ʾӷŴ
	int x = point.x - 10;		//ʾ
	int y = point.y - 10;
	if (x>0 && x<352 && y>0 && y< 288)	//ڻʾ
	{
		JVSP_ZoomIn(g_pconfig.PLAYER[m_nCurSel].nPlayer, TRUE, x, y);
		g_pconfig.PLAYER[m_nCurSel].bZoomIn = TRUE;
	}
	
	CDialog::OnRButtonDblClk(nFlags, point);
}

void CJVSDKPDEMODlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	//ʾȡӷŴ
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer == -1)
		return;

	if (g_pconfig.PLAYER[m_nCurSel].bZoomIn)
	{
		int x = point.x - 10;		//ʾ
		int y = point.y - 10;
		if (x>0 && x<352 && y>0 && y< 288)
		{
			JVSP_ZoomIn(g_pconfig.PLAYER[m_nCurSel].nPlayer, FALSE, 0, 0);
			g_pconfig.PLAYER[m_nCurSel].bZoomIn = FALSE;
		}
	}

	
	CDialog::OnLButtonDblClk(nFlags, point);
}

void CJVSDKPDEMODlg::OnButtonBackIdr() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer == -1)
		return;

	ULONG ulFrame = JVSP_GetCurFrameNum(g_pconfig.PLAYER[m_nCurSel].nPlayer);
	if (ulFrame != 0)
		ulFrame--;
	JVSP_GotoKeyFrame(g_pconfig.PLAYER[m_nCurSel].nPlayer, ulFrame, TRUE);
	
}

void CJVSDKPDEMODlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	
	// TODO: Add your message handler code here
	if (m_bInit)
	{
		RECT rt;
		GetWindowRect(&rt);
		rt.left += 13;
		rt.right = rt.left + 352;
		rt.top += 32;
		rt.bottom = rt.top + 288;
		JVSP_SetVideoPreview(g_pconfig.PLAYER[m_nCurSel].nPlayer, GetSafeHwnd(), &rt, TRUE);
	}
	
}

void CJVSDKPDEMODlg::OnButtonLink() 
{
	// TODO: Add your control notification handler code here
	if (g_pconfig.PLAYER[m_nCurSel].nPlayer == -1)
	{
		m_lstInfo.AddString("Player has not created successfully");
		return;
	}
	g_pconfig.PLAYER[m_nCurSel].nPort = GetDlgItemInt(IDC_EDIT_PORT);
	GetDlgItemText(IDC_EDIT_IP, g_pconfig.PLAYER[m_nCurSel].szIP, 16);
	m_JdvrSock.m_nChannel = 0;
	m_JdvrSock.m_hParent = this;

	m_JdvrSock.StartLink();
}

void CJVSDKPDEMODlg::OnButtonUnlink() 
{
	// TODO: Add your control notification handler code here
	m_JdvrSock.StopLink();
}

void CJVSDKPDEMODlg::OnCheckPlayAudio() 
{
	// TODO: Add your control notification handler code here
	JVSP_SetAudioPreview(g_pconfig.PLAYER[m_nCurSel].nPlayer, GetSafeHwnd(), ((CButton *)GetDlgItem(IDC_CHECK_PLAY_AUDIO))->GetCheck());
	
}

void CJVSDKPDEMODlg::GetSdkBitmap(int nPlayer)
{
	if (g_pconfig.PLAYER[nPlayer].Bitmap.pRGB == NULL)
	{
		return;
	}
	int nWidth = g_pconfig.PLAYER[nPlayer].Bitmap.dwWidth;
	int nHeight = g_pconfig.PLAYER[nPlayer].Bitmap.dwHeight;
	int nBits = 4;
	ULONG ulSize = nWidth * nHeight * nBits;
	FILE * fout = fopen("bitmap.bmp", "wb");
	if (fout)
	{
		BITMAPFILEHEADER bmHeader;
		memset(&bmHeader, 0, sizeof(bmHeader));
		bmHeader.bfType = 0x4D42;
		bmHeader.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + nWidth * nHeight * nBits;
		bmHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

		BITMAPINFOHEADER bmInfo;
		memset(&bmInfo, 0, sizeof(bmInfo));
		bmInfo.biSize = sizeof(bmInfo);
		bmInfo.biWidth	=	nWidth;
		bmInfo.biHeight	=	nHeight;
		bmInfo.biPlanes	=	1;
		bmInfo.biBitCount	=	nBits * 8;
		bmInfo.biCompression	=	0;
		bmInfo.biSizeImage	=	nWidth * nHeight * nBits;
		bmInfo.biXPelsPerMeter	=	300;
		bmInfo.biYPelsPerMeter	=	300;

		fwrite(&bmHeader, sizeof(bmHeader), 1, fout);
		fwrite(&bmInfo, sizeof(bmInfo), 1, fout);
		fwrite(g_pconfig.PLAYER[nPlayer].Bitmap.pRGB, nWidth * nHeight * nBits, 1, fout);

		fclose(fout);
		m_lstInfo.SetCurSel(m_lstInfo.AddString("Capture successfully! Saved to \"bitmap.bmp\""));
		//ͷRGB
		delete[] g_pconfig.PLAYER[nPlayer].Bitmap.pRGB;
		g_pconfig.PLAYER[nPlayer].Bitmap.pRGB = NULL;
	}

}

void CJVSDKPDEMODlg::OnButtonPlayKeyframe() 
{
	// TODO: Add your control notification handler code here
	JVSP_PlayKeyFrame(g_pconfig.PLAYER[m_nCurSel].nPlayer, GetDlgItemInt(IDC_EDIT_PLAY_INTERVAL));
}

void CJVSDKPDEMODlg::OnButtonStopKeyframe() 
{
	// TODO: Add your control notification handler code here
	JVSP_PlayKeyFrame(g_pconfig.PLAYER[m_nCurSel].nPlayer, 0);
	
}


void CJVSDKPDEMODlg::OnCHECKC501Output() 
{
	g_pconfig.MATRIX[0].bEnableOutput = ((CButton *)GetDlgItem(IDC_CHECK_C501Output))->GetCheck();
	//Ŀǰ󿨽֧352x288ķֱ
	JVM_EnableOutput(0, g_pconfig.MATRIX[0].bEnableOutput, 352, 288);
	
}

//SDKڽݺʹõĻص
void FuncYv12Callback(int nPlayer, PUCHAR pY, PUCHAR pU, PUCHAR pV, DWORD dwStrideY, DWORD dwStrideUV)
{
	if (g_pconfig.MATRIX[0].bEnableOutput)
	{
		JVM_OutputData(0,0, pY, pU, pV, dwStrideY, dwStrideUV);
	}
}
