/*////////////////////////////////////////////////////////////////////////////////
// JVSDK.h
// JVSDK ̬ӿĵͷļӦóӦͷļ
// άͿƼ޹˾
// 20100226
// JVSDKɼĳʼԤѹõȹܣΪϲӦóṩο
// SDKC룬C++ʹʱҪextern "C"{}
//////////////////////////////////////////////////////////////////////////////////*/

#ifndef		_JVSDK_H
#define		_JVSDK_H

#ifdef __cplusplus
#define JVSDK_API extern "C" __declspec(dllexport)
#else
#define JVSDK_API __declspec(dllexport)
#endif

typedef void  (*CALLBACK_ENC_DATA)(int nChannel, PUCHAR pData, UINT nBuffLen, int nFrameType, BOOL bMov);
typedef void  (*CALLBACK_RAW_DATA)(int nChannel, PUCHAR pRawBuffer, DWORD dwVideo, DWORD dwHD1);

//SDK֪ͨϢ
#define	JVS_WM_BITMAP_OK	0x01		//ץͼ
#define JVS_WM_COPYRIGHT	0x02		//ͨȨ֤

//֡
#define JVS_TYPE_P			0x00		
#define JVS_TYPE_IDR		0x01
#define JVS_TYPE_AUD		0x02
#define JVS_TYPE_SKIP		0x03
#define JVS_TYPE_D			0x04

#define JVE_TYPE_AUD		0x07

//USBȲηֵ
#define JVS_DEVICE_NOEVENT	0x00
#define JVS_DEVICE_LOST		0x01
#define JVS_DEVICE_FIND		0x02


typedef struct _JVS_FILE_HEADER
{
	DWORD	dwFLAGS;			//ά¼ļͷ־ֶ
	DWORD	dwFrameWidth;		//֡
	DWORD	dwFrameHeight;		//֡
	DWORD	dwTotalFrames;		//֡
	DWORD	dwVideoFormat;		//ԴƵʽ0ʾPAL1ʾNTSC
	DWORD	bThrowFrame;		//Ƿ֡0ʾ֡1ʾ֡ģʽ
	DWORD	dwReserved1;		//ֶ
	DWORD	dwReserved2;		//ֶ
} JVS_FILE_HEADER, *PJVS_FILE_HEADER;

typedef struct _MP4_HEADER
{
	int					i_sps_size;			// spsݴС
	int					i_pps_size;			// ppsݴС
	int					i_sei_size;			// Ŀǰδʹ
	   
	unsigned char *		p_sps;				// spsָ
	unsigned char *		p_pps;				// ppsָ
	unsigned char *		p_sei;				// Ŀǰδʹ
	
}MP4_HEADER, *PMP4_HEADER;

typedef struct _JVS_CARD_INFO
{
	DWORD	dwCardType;		//
	DWORD	dwGroup;		//
	DWORD	dwSerialNum;	//к
	DWORD	dwDateTime;		//
	DWORD	dwGUID[4];		//GUID16ֽ
} JVS_CARD_INFO, *PJVS_CARD_INFO;

//豸
enum USBDeviceType
{
	USBDT_C300,
	USBDT_C301,

	USBDT_Unknown
};

//ADоƬ
enum JVS_CHIP_TYPE_ENUM
{
	JVS_CHIP_6802B		=	0x00,
	JVS_CHIP_25837		=	0x01,
	JVS_CHIP_1104		=	0x02,
	JVS_CHIP_244		=	0x03,
	JVS_CHIP_1204		=	0x04,
	JVS_CHIP_2812		=	0x05,
	JVS_CHIP_2864		=	0x06,
	JVS_CHIP_2867       =   0X07,
	JVS_CHIP_26844      =   0X08,
	JVS_CHIP_26824		=	0x09,
	JVS_CHIP_6366		=	0x0a,
	JVS_CHIP_6366A		=	0x0b,
	JVS_CHIP_UNKNOW		=	0xFF
};


/////////////////////////////ʼͷSDKԴ////////////////////////////////////
//hWnd:SDKϢUSB¼Ĵھ
//dwNotifyMsgSDKϢʹõϢID
////////////////////////////////////////////////////////////////////////////////////
JVSDK_API	int		__stdcall	JVS_InitSDK(HWND hWnd, DWORD dwNotifyMsg);
JVSDK_API	void	__stdcall	JVS_ReleaseSDK();

////////////////////////////////ͨǰۺ////////////////////////////////
//עѹݴĻص
JVSDK_API	void	__stdcall	JVS_SetCallBack(CALLBACK_ENC_DATA cbEncData, CALLBACK_ENC_DATA cbNetEncData, CALLBACK_RAW_DATA cbRawData);
//ƵźʱSDKͼƬ
JVSDK_API	void	__stdcall	JVS_SetNoSignalFile(char * szBmpCIF, char *szNoDeviceBmpCIF);


//////////////////////////////////رͨ/////////////////////////////////////
JVSDK_API	BOOL	__stdcall	JVS_OpenChannel(int nChannel);	//ͨ0ͨʼ
JVSDK_API	void	__stdcall	JVS_CloseChannel(int nChannel);	//رͨ0ͨʼ


//////////////////////////////////ͨۺ////////////////////////////////
//Ƶֱģʽ
JVSDK_API	void	__stdcall	JVS_SetVideoPixelMode(int nChannel, DWORD dwPixelMode, DWORD dwVideoFormat, BOOL bWideMode);
//
JVSDK_API	void	__stdcall	JVS_StartCapture(int nChannel);


//////////////////////////////////////////Ԥ////////////////////////////////////////
JVSDK_API	BOOL	__stdcall	JVS_InitPreview();
JVSDK_API	void	__stdcall	JVS_ReleasePreview();
JVSDK_API	BOOL	__stdcall	JVS_SetVideoPreview(int nChannel, HWND hWnd, RECT * rt, BOOL bPreview);
JVSDK_API	BOOL	__stdcall	JVS_SetAudioPreview(int nChannel, HWND hWnd, BOOL bPreview);


////////////////////////////////////////ѹ//////////////////////////////////////////
JVSDK_API	BOOL	__stdcall	JVS_InitCompress();
JVSDK_API	void	__stdcall	JVS_ReleaseCompress();
JVSDK_API	BOOL	__stdcall	JVS_StartCompress ( int nChannel );	//ʼѹ
JVSDK_API	void	__stdcall	JVS_StopCompress( int nChannel, BOOL bWaitForStop );
//ѹģʽ
JVSDK_API	void	__stdcall	JVS_SetQualityMode(int nChannel, DWORD dwPixelMode, DWORD dwQualityMode, DWORD   dCompressPreset,DWORD dRate,DWORD dFrameRate);
JVSDK_API	void	__stdcall	JVS_SetQualityModeNet(int nChannel, BOOL bCompressNet, DWORD dwPixelMode, DWORD dwQualityMode, DWORD   dCompressPreset,DWORD dRate,DWORD dFrameRate);
JVSDK_API	void	__stdcall	JVS_SetKeyFramePeriod(int nChannel, DWORD dwKeyFramePeriod);
JVSDK_API	void	__stdcall	JVS_InsertKeyFrame(int nChannel);
JVSDK_API	BOOL	__stdcall	JVS_SetAudioCompress(int nChannel, BOOL bCompress);
JVSDK_API	BOOL	__stdcall	JVS_SetAudioCompressNet(int nChannel, BOOL bCompress);
//ȡѹļͷ
JVSDK_API	BOOL	__stdcall	JVS_GetHeaderData(int nChannel, PJVS_FILE_HEADER pheaderData);
JVSDK_API	BOOL	__stdcall	JVS_GetHeaderDataNet(int nChannel, PJVS_FILE_HEADER pheaderData);
JVSDK_API	BOOL	__stdcall	JVS_GetHeaderMP4(int nChannel, PMP4_HEADER pheaderMP4);
JVSDK_API	BOOL	__stdcall	JVS_GetHeaderMP4net(int nChannel,  PMP4_HEADER  pheaderMP4);

////////////////////////////////////////ץͼ//////////////////////////////////////////
JVSDK_API	BOOL	__stdcall	JVS_GetBitmapSize(int nChannel, DWORD * dwWidth, DWORD * dwHeight);
JVSDK_API	BOOL	__stdcall	JVS_GetBitmap(int nChannel, PUCHAR pBuffer);
JVSDK_API	BOOL	__stdcall	JVS_GetBitmapToFile(int nChannel, PUCHAR pCapBmpFile);

///////////////////////////////////////ƶ//////////////////////////////////////
JVSDK_API	void	__stdcall	JVS_SetMovDetect(int nChannel, int nScenecutGrade, int nScenecutThreshold, int nScenecutCoeff, int nRectNumber, RECT * pScenecutRect);


//////////////////////////////////////Ƶ////////////////////////////////////////
JVSDK_API	void	__stdcall	JVS_SetOSD(int nChannel, DWORD dwOsdMode, PUCHAR pText, BOOL bEnable);
JVSDK_API	void	__stdcall	JVS_SetOSD2 ( int nChannel, PUCHAR pkbpsText, PUCHAR pCurLinksText, PUCHAR pLinksText, BOOL bEnable );
JVSDK_API	void	__stdcall	JVS_SetOSD2Values ( int nChannel, DWORD dwValue1, DWORD dwValue2, DWORD dwValue3 );
JVSDK_API	void	__stdcall	JVS_SetVideoPara(int nChannel, int nBrightness, int nContrast, int nSatuation, int nHue);
JVSDK_API	void	__stdcall	JVS_EnableVideoClean(int nChannel, BOOL bVideoClean);

//Ƶڵ
JVSDK_API	void	__stdcall	JVS_SetVideoMask(int nChannel, BOOL bEnableMask, BOOL bMaskToRec, DWORD nMaskX, DWORD nMaskY, DWORD nWidth, DWORD nHeight);
JVSDK_API	void	__stdcall	JVS_SetVideoCrop(int nChannel, DWORD dwPixelCroped);


///////////////////////////////////////Ƶ///////////////////////////////////////
JVSDK_API	BOOL	__stdcall	JVS_SetVolume(int nChannel, DWORD dwVolume);


///////////////////////////////////////忨Ϣ///////////////////////////////////////
JVSDK_API	BOOL	__stdcall	JVS_GetCardInfo(int nChannel, PJVS_CARD_INFO pCardInfo);

///////////////////////////////////////USBȲ¼//////////////////////////
JVSDK_API	int	__stdcall	JVS_USBDeviceMessage(UINT nEventType, DWORD dwData);

///////////////////////////////////////ȡUSB豸//////////////////////////
JVSDK_API	int	__stdcall	JVS_USBDeviceNumber();

///////////////////////////////////////ȡоƬ//////////////////////////
JVSDK_API	BOOL __stdcall	JVS_GetChipType(int nChannel, DWORD *pdwDeviceType, DWORD *pdwChipType);

///////////////////////////////////////ADʵʱʵʱģʽ////////////////////////////
JVSDK_API	BOOL __stdcall	JVS_SetChipMode(BOOL bD1Mode, BOOL bC1RealTime, BOOL bC2RealTime, BOOL bC3RealTime, BOOL bC4RealTime);

///////////////////////////////////////USB豸////////////////////////////
JVSDK_API	BOOL __stdcall	JVS_ReConnectUSB(int nChannel);

#endif